/*


IFT1166 - Structures de donnes de base

13-novembre  -2005 v1.01             M.Lokbani  partir des ex-notes de cours
30-octobre   -1999 v1.00             M.Lokbani

contact: lokbani@iro.umontreal.ca


    Copyright (C) 1999-2005 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------

    Le fichier suivant prsente la dfinition des diffrentes mthodes des classes Cellule et Liste.

    Nous avons besoin d'inclure le fichier "liste1166.h" pour signifier au compilateur o aller
    chercher la dclaration des classes Cellule et liste1166 qui contiennent la signature des
    diffrentes mthodes.
    
                liste1166.h : dclaration de la classe liste
    ========>   liste1166.cpp: dfinition des diffrentes mthodes de la classe liste
                mainliste.cpp: programme de test


*/

#include "liste1166.h"


using namespace std;

// Mthodes de la classe Cellule


Cellule::Cellule(int v, Cellule* suivant){
    valeur = v;
    prochain = suivant;
}
Cellule* Cellule::get_prochain(){
    return prochain;
}
void Cellule::set_prochain(Cellule* suivant){
    prochain = suivant;
}
int Cellule::get_valeur(){
    return valeur;
}


// Mthodes de la classe Liste

Liste::Liste(){
    tete = queue = NULL;
    longueur=0;
}

void Liste::ajout_tete(int v) {
    Cellule* t = new Cellule(v,tete);
    tete = t;
    longueur++;
    if (queue == NULL) queue=t; // si t est le 1er lment ajout.
}

void Liste::ajout_queue(int v) {
    if (queue == NULL)
        tete=queue= new Cellule(v,NULL);
    else {
        Cellule* t = new Cellule(v,NULL);
        queue->set_prochain(t);
        queue = t;
    }
    longueur++;
}

void Liste::ajout_liste(Liste* l) {
    if (queue==NULL){
        queue=l->queue;
        tete=l->tete;
    }else{
        queue->set_prochain(l->tete);
        queue = l->queue;
    }
    longueur += l->longueur;
}

void Liste::affiche(){
    Cellule* t = tete;
    while(t){
            cout << t->get_valeur();
            t=t->get_prochain();
            if (t) cout << " ";
    }
    cout << endl;
}

void Liste::efface(){
    while(tete!=NULL){
        Cellule* courant = tete;
        tete = tete->get_prochain();
        delete courant;
    }
}

