/*


IFT1166 - Structures de donnes de base

13-novembre  -2005 v1.01             M.Lokbani  partir des ex-notes de cours
30-octobre   -1999 v1.00             M.Lokbani

contact: lokbani@iro.umontreal.ca


    Copyright (C) 1999-2005 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------

    Le fichier suivant prsente la dclaration de la classe Liste.
    Cette liste est une structure de donnes contenant des lments
    du type Cellule. Ces lments correspondent  des marques de dbut
    et de fin de la liste.
    Ces lments sont du type Cellule. Chaque Cellule contient une valeur
    du type int et un lien avec sa Cellule suivante.
    La liste dveloppe dans cet exemple, est une liste simplement chane car
    il y a un seul lien et il est avec l'lment suivant.
    
    Nous avons utilis "ifndef/define/endif" pour empcher de multiples
    inclusions du fichier d'en-tte et viter ainsi une redclaration de la classe.
    
    Il est conseill de dclarer les classes dans un fichier d'en-tte (*.h).
    
     signaler que nous avons dcid de respecter  la lettre le principe d'encapsulation.
    Ainsi donc les mthodes des classes Cellule et Liste ont t dfinies dans un fichier
     part: liste1166.cpp
    Nous pouvions sparer les classes aussi chacune dans un fichier appropri, mais nous avons
    jug que cela n'tait pas utile vu que les deux classes sont pour un "bien commun".
    
    Si un programmeur veut intgrer la classe liste dans ses programmes, pas besoin de lui fournir
    le fichier liste1166.cpp qui contient le code source de notre programme. Il peut se contenter
    des fichiers liste1166.h qui dcrit la classe et ses mthodes et liste1166.o le code objet obtenu suite
     la compilation de liste1166.cpp Ainsi le programmeur sait quoi utiliser et comment le faire mais
    ne peut pas modifier le contenu de liste1166.cpp (il ne l'a pas! il a juste liste1166.o) pour faire
    faire  la liste quelque chose d'autre non prvue.


    Nous avons dcid d'appeler ce fichier liste1166 pour viter d'inclure un fichier list.h/cpp
    (ou) liste.h/cpp qui peut tre rendu disponible par un autre programmeur ou le systme lui mme

    Le programme permettant de tester cette classe est lui aussi  part. Il porte le nom de mainliste.cpp



    La compilation de ce programme peut se faire soit:
    
        - compiler les programme sparment i.e:
            g++ -Wall -c liste1166.cpp
            g++ -Wall -c mainliste.cpp
            g++ -Wall -o mainliste mainliste.o liste1166.o
            
        - en une seule opration:
            g++ -Wall -o mainliste liste1166.cpp mainliste.cpp



    ========>   liste1166.h : dclaration de la classe liste
                liste1166.cpp: dfinition des diffrentes mthodes de la classe liste
                mainliste.cpp: programme de test



*/

#include <iostream>

using namespace std;

#ifndef H_LISTE
#define H_LISTE

class Cellule {
    int valeur;
    Cellule* prochain;
public:
    // Constrcuteur
    Cellule(int v, Cellule* suivant);
    // obtenir la valeur de son prochain
    Cellule* get_prochain();
    // fixer la valeur de son prochain
    void set_prochain(Cellule* suivant);
    // obtenir la valeur associe  la cellule
    int get_valeur();
};

class Liste {
    Cellule *tete, *queue;
    int longueur;
public:
    // Constructeur
    Liste();
    // Ajoute un lment au dbut
    void ajout_tete(int x);
    // Ajoute un lment  la fin
    void ajout_queue(int x);
    // Ajoute une autre liste  la fin
    void ajout_liste(Liste *l);
    // Affiche le contenu de la liste
    void affiche();
    // Efface tout le contenu de la liste
    void efface();
};

#endif
