/*


IFT1166 - Structures de donnes de base

13-novembre  -2005 v1.01             M.Lokbani  partir des ex-notes de cours
30-octobre   -1999 v1.00             M.Lokbani

contact: lokbani@iro.umontreal.ca


    Copyright (C) 1999-2005 Universit de Montral
            Dpartement d'informatique et de Recherche Oprationnelle
            Mohamed Lokbani
    -- Tous Droits Rservs -- All Rights Reserved --

Description:
------------

    Le fichier suivant prsente la dclaration de la classe Pile.
    Cette pile est une structure de donnes contenant des lments
    du type int. Elle permet de grer les 2 oprations :
        - push (empiler)
        - pop (dpiler)
    Elle est du type LIFO (LastInFirstOut)

    Nous avons utilis "ifndef/define/endif" pour empcher de multiples
    inclusions du fichier d'en-tte et viter ainsi une redclaration de la classe.
    
    Il est conseill de dclarer les classes dans un fichier d'en-tte (*.h).
    
     signaler que nous avons dcid de respecter  la lettre le principe d'encapsulation.
    Ainsi donc les mthodes de la classe Pile ont t dfinies dans un fichier  part: pile.cpp
    Si un programmeur veut intgrer la classe Pile dans ses programmes, pas besoin de lui fournir
    le fichier pile.cpp qui contient le code source de notre programme. Il peut se contenter
    des fichiers pile.h qui dcrit la classe et ses mthodes et pile.o le code objet obtenu suite
     la compilation de pile.cpp Ainsi le programmeur sait quoi utiliser et comment le faire mais
    ne peut pas modifier le contenu de pile.cpp (il ne l'a pas! il a juste pile.o) pour faire
    faire  la pile quelque chose d'autre non prvue.
    
    Le programme permettant de tester cette classe est lui aussi  part. Il porte le nom de mainpile.cpp


    La compilation de ce programme peut se faire soit:
    
        - compiler les programme sparment i.e:
            g++ -Wall -c pile.cpp
            g++ -Wall -c mainpile.cpp
            g++ -Wall -o mainpile mainpile.o pile.o
            
        - en une seule opration:
            g++ -Wall -o mainpile pile.cpp mainpile.cpp



    ========>   pile.h : dclaration de la classe pile
                pile.cpp: dfinition des diffrentes mthodes de la classe pile
                mainpile.cpp: programme de test



*/


#include <iostream>
#include <string>

using namespace std;

#ifndef H_PILE
#define H_PILE

class Pile {

public:
    // Par dfaut la pile va contenir 50 lments.
    enum { DefautPile = 50, VidePile = -1 };
    
    // Constructeur vide, on va prendre la taille par dfaut.
    Pile();
    
    // Constructeur  un argument, la taille de la pile.
    Pile( int );
    
    // Destructeur.
    ~Pile();

    // Fonction permettant d'insrer un lment dans la pile.
    void push( const int& );
    
    // Fonction permettant de retourner l'lment au somment de la pile.
    int pop();
    
    // Test si la pile est vide.
    bool vide() const;
    
    // Test si la pile est pleine.
    bool pleine() const;

private:

    // Les lments de la pile du type int.
    
    int* elements;
    
    // La taille relle
    int sommet;
    
    // La taille max
    int taille;

    // Fonction d'allocation des lments.
    void allocation() {
        elements = new int[ taille ];
        test_alloc();
        sommet = VidePile;
    }
    // Pour tester si l'allocation est ok.
    void test_alloc () {
        if (elements==NULL) {
            cerr << "problemes a l'allocation memoire de elements\n";
            exit(1);
        }
    }
    // Fonction d'affichage de messages.
    void msg( const char* m ) const {
        cout << "*** " << m << " ***" << endl;
    }
};

#endif


